
#include "NewRadixSet.hh"

#include <iostream>

int main(void)
{
    typedef NewRadixSet<char, 127, 5> SetType;
    /* Create a set of items
     * consisting of 5 chars of maximum value 127
     */
    SetType set;
    
    #define Add(x) \
        std::cout << "Listn '" << x << "'... "; \
        if(set.add(x)) std::cout << " - onnistui\n"; \
        else std::cout << " - oli jo setiss\n";
    #define Find(x) \
        if(set.find(x)) \
            std::cout << "Setist lytyy '" << x << "'\n"; \
        else \
            std::cout << "Setist ei lydy '" << x << "'\n";
    
    Add("koira");
    Add("kissa");
    Add("testi");
    Add("maito");
    Add("testi");
    Add("kahvi");
    Add("testi");
    Add("koira");
    
    Find("koira");
    Find("kissa");
    Find("kahvi");
    Find("maito");
    Find("tahti");
    Find("testi");

    return 0;
}
